/****************************************************!
* jwsApps JavaScript Library for Jexus Web server.
* Version: 1.0
* Copyright 2012, WWW.J66.NET
*****************************************************/

(function (window) {

    var jwsApps;
    if ((!window.jwsApps) || typeof (window.jwsApps) != "object")
        jwsApps = {};
    else
        return;

    // Create XMLHttpRequest object.
    //////////////////////////////////////
    var CreateHttpRequest = function () {
        var http_request = false;
        if (window.XMLHttpRequest) {
            http_request = new XMLHttpRequest();
            if (http_request.overrideMimeType) {
                http_request.overrideMimeType('text/xml');
            }
        }
        else if (window.ActiveXObject) {
            try {
                http_request = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e) {
                try {
                    http_request = new ActiveXObject("Msxml2.XMLHTTP");
                } catch (e1) {
                    http_request = false;
                }
            }
        }
        return http_request;
    };



    ////////////////////////
    // CLASS "svrPush"
    ////////////////////////////////////////
    jwsApps.svrPush = function (userID, eventCallbackFunc) {

        // PRIVATEs:

        var _this = this;
        var _xmlRequest = CreateHttpRequest();
        var _pushEventCBF = eventCallbackFunc;
        var _pushConnectNode = "/_broadcast/" + userID + "/?rd=";

        var GetInternalCallbackFunc = function () {
            var _reStart = _this.start;
            return function () {
                if (_xmlRequest.readyState != 4) return;
                var reqStatus = _xmlRequest.status;
                if (reqStatus == 200) {
                    var text = _xmlRequest.responseText;    //ı
                    if (text != "") _pushEventCBF(200, text);
                } else {
                    _pushEventCBF(reqStatus, "");
                }

                //404: Server does not have this user id, do not re-polling.
                if (reqStatus == 404) return;
                //1223: Client canceled request.
                if (reqStatus == 1223) return;
                //12029-12031: Dropped connection.
                if (reqStatus > 12028 && reqStatus < 12032) return;

                _xmlRequest.abort();
                _reStart();

                //12152: Connection closed by server.

            }
        };


        // PUBLICs:

        _this.start = function () {
            if (!_xmlRequest) return;
            var urlPath = _pushConnectNode + Math.round(Math.random() * 10000);
            _xmlRequest.onreadystatechange = GetInternalCallbackFunc();
            _xmlRequest.open("GET", urlPath, true);
            _xmlRequest.send(null);
        };

    };  //END CLASS: svrPush.



    ///////////////
    // Expose "jwsApps" to the global object!
    //////////////////////////////////////////////
    window.jwsApps = jwsApps;
})(window);

